<?php

 /* Statistiques par période ---------------------------------------------------------
	Nb Pages
	Nb IP
	Nb Images
   par :
	total
	années
	années/mois
	années/mois/jour
	années/mois/heures
 ------------------------------------------------------------------------------------ */
 function stats_by_period($total, $year, $month, $day)
 {
	$returned = array();
	$delta = 0;


	$sql = "count(id) as NbPages, count(distinct IP) as NbIP, count(image_id) as NbImg, count(distinct category_id) as NbCat ";
        $sql_nfomax = ", MaxPages, MaxIP, MaxImg";
	$sql_from = " from ".HISTORY_TABLE." ";
	$sql_where = "";
	$sql_order = "";
	$sql_select = "";
	$sql_group = "";



	if($day!="") 
	{ 
		$sql_select="select hour as Id, ";
		$sql_where=" where year = $year and month = $month and day = $day ";	
		$sql_group=" group by hour ";
		$sql_order=" order by hour asc"; 

		for($i=0;$i<24;$i++) 
		{ $returned[$i] = array("Id" => $i, "NbPages" => 0, "NbIP" => 0, "NbImg" => 0, "NbCat"=>0, "MaxPages" => 0, "MaxIP" => 0, "MaxImg" => 0); }
	}
	elseif($month!="") 
	{ 
		$sql_select="select day as Id, ";
		$sql_where=" where year = $year and month = $month ";
		$sql_group=" group by day ";
		$sql_order=" order by day asc"; 

		$delta = 1;
		$NbDays = strftime('%d', mktime(0,0,0,$month+1,0,$year));
		for($i=0;$i<$NbDays;$i++) 
		{ $returned[$i] = array("Id" => $i+1, "NbPages" => 0, "NbIP" => 0, "NbImg" => 0, "NbCat"=>0, "MaxPages" => 0, "MaxIP" => 0, "MaxImg" => 0); }
	}
	elseif($year!="") 
	{ 
		$sql_select="select month as Id, ";
		$sql_where=" where year = $year ";
		$sql_group=" group by month ";
		$sql_order=" order by month asc "; 

		$delta = 1;
		for($i=0;$i<12;$i++) 
		{ $returned[$i] = array("Id" => $i+1, "NbPages" => 0, "NbIP" => 0, "NbImg" => 0, "NbCat"=>0, "MaxPages" => 0, "MaxIP" => 0, "MaxImg" => 0); }
	}
	elseif($total!="Y") 
	{ 
		$sql_select="select year as Id, ";
		$sql_group=" group by year ";
		$sql_order=" order by year desc"; 
	}
	else { $sql_select="select 'Tout' as Id, "; $sql_nfomax=", 0 as MaxPages, 0 as MaxIP, 0 as MaxImg"; }


	$sql_max=", (select max(n.MaxPages) as MaxPages, max(n.MaxIP) as MaxIP, max(n.MaxImg) as MaxImg 
			from (select count(id) as MaxPages, count(distinct IP) as MaxIP, count(image_id) as MaxImg 
					from ".HISTORY_TABLE.$sql_where.$sql_group.") as n) as n ";	
	$sql=$sql_select.$sql.$sql_nfomax.$sql_from.$sql_max.$sql_where.$sql_group.$sql_order;
	
	$result = pwg_query($sql);

	$i=0;
	while ($row = mysql_fetch_array($result))
	{
		if($year.$month.$day=="")
		{ $returned[$i] = $row; $i++; }
		else
		{ $returned[$row["Id"]-$delta] = $row; }
	}
	
	return($returned);
 }


 /* Statistiques par IP --------------------------------------------------------------
	Nb Pages
	Nb Images
   par : 
	IP
	IP/années
	IP/années/mois
	IP/années/mois/jour
 ------------------------------------------------------------------------------------ */
 function stats_by_ip($year, $month, $day, $nbipperpage, $pagenumber, $sortip)
 {
	$returned0 = array();
	$sortlist = array("page" => "NbPages desc", "picture" => "NbImg desc", "ip" => "IP asc");


	$sql_select="select SQL_CALC_FOUND_ROWS ";
	$sql = "if(".HISTORY_TABLE.".user_id = 2, IP, if(".USERS_TABLE.".username is null, ' [".l10n("AStat_deleted_user")."]', CONCAT(' ', ".USERS_TABLE.".username))) as IP, count(".HISTORY_TABLE.".id) as NbPages, count(image_id) as NbImg ";
        $sql_nfomax = ", MaxPages, MaxImg";
	$sql_from = " from ".HISTORY_TABLE." LEFT JOIN ".USERS_TABLE." ON ".HISTORY_TABLE.".user_id = ".USERS_TABLE.".id ";
	$sql_where = "";
	$sql_group=" group by IP ";
	$sql_order=" order by ".$sortlist[$sortip]." "; 
	$sql_limit=" limit ".(($pagenumber-1)* $nbipperpage).", ".$nbipperpage;


	if($day!="") 
	{ 
		$sql_where=" where year = $year and month = $month and day = $day ";	
	}
	elseif($month!="") 
	{ 
		$sql_where=" where year = $year and month = $month ";
	}
	elseif($year!="") 
	{ 
		$sql_where=" where year = $year ";
	}
	else { $sql_nfomax = ", 0 as MaxPages, 0 as MaxImg"; }

/*
	if($sql_where=="") { $sql_where=" where ".$sql_where; } else { $sql_where=" and ".$sql_where; }
        $sql_where.=" image_id > 0 ";
*/

	$sql_max=", (select max(n.MaxPages) as MaxPages, max(n.MaxImg) as MaxImg 
			from (select if(".HISTORY_TABLE.".user_id = 2, IP, if(".USERS_TABLE.".username is null, '[".l10n("AStat_deleted_user")."]', ".USERS_TABLE.".username)) as IP, count(".HISTORY_TABLE.".id) as MaxPages, count(image_id) as MaxImg 
					from ".HISTORY_TABLE." LEFT JOIN ".USERS_TABLE." ON ".HISTORY_TABLE.".user_id = ".USERS_TABLE.".id ".$sql_where.$sql_group.") as n) as n ";	
	$sql=$sql_select.$sql.$sql_nfomax.$sql_from.$sql_max.$sql_where.$sql_group.$sql_order.$sql_limit;

	$result = pwg_query($sql);
	$sql="select FOUND_ROWS()";

	$i=0;
	while ($row = mysql_fetch_array($result))
	{
		$returned0[$i] = $row; $i++;
	}
	$returned[0] = $returned0;

	$result = pwg_query($sql);
	if($result) { $row = mysql_fetch_array($result); $returned[1] = $row[0]; } else { $returned[1] = -1; }
	
	return($returned);
 }



 /* Statistiques par catégories ------------------------------------------------------
	%Pages
	%Images
   par : 
	Catégories
	Catégories/années
	Catégories/années/mois
	Catégories/années/mois/jour
 ------------------------------------------------------------------------------------ */
 function stats_by_category($year, $month, $day, $nbipperpage, $pagenumber, $show_thumb, $sortcat)
 {
	$sortlist = array("page" => "PctPages desc, PctImg desc", "picture" => "PctImg desc, PctPages desc", "nbpicture" => "RatioImg desc, PctPages desc");
	$returned0 = array();

	$sql_select="select SQL_CALC_FOUND_ROWS ";
	$sql = "category_id, if(category_id > 0, ".CATEGORIES_TABLE.".name, section) as IdCat, 
count(".HISTORY_TABLE.".id) as NbPages, MaxPages.somme, 100*(count(".HISTORY_TABLE.".id)/MaxPages.somme) as PctPages,
count(".HISTORY_TABLE.".image_id) as NbImg, MaxImg.somme, 100*(count(".HISTORY_TABLE.".image_id)/MaxImg.somme) as PctImg, ".CATEGORIES_TABLE.".nb_images as NbImgCat, (count(".HISTORY_TABLE.".image_id)/".CATEGORIES_TABLE.".nb_images) as RatioImg, greatest(100*(count(".HISTORY_TABLE.".id)/MaxPages.somme), 100*(count(".HISTORY_TABLE.".image_id)/MaxImg.somme)) as MaxPct ";

	if($show_thumb=='true')
	{ 
		$sql_thumb = ', '.IMAGES_TABLE.'.path as ThumbPath, '.IMAGES_TABLE.'.file as ThumbFile, '.IMAGES_TABLE.'.tn_ext as Extension';
		$sql_fromthumb = "LEFT JOIN ".IMAGES_TABLE." ON ".CATEGORIES_TABLE.".representative_picture_id = ".IMAGES_TABLE.".id  ";
	}
	else
	{
		$sql_thumb = "";
		$sql_fromthumb = "";
	}
	
	$sql_from = " from (".HISTORY_TABLE." LEFT JOIN ".CATEGORIES_TABLE." ON ".CATEGORIES_TABLE.".id = ".HISTORY_TABLE.".category_id) ";
	$sql_where = "";
	$sql_group=" group by category_id, section ";
	$sql_group2="";
	$sql_order=" order by ".$sortlist[$sortcat]; 
	$sql_limit=" limit ".(($pagenumber-1)* $nbipperpage).", ".$nbipperpage;

	if($day!="") 
	{ 
		$sql_where=" where year = $year and month = $month and day = $day ";	
	}
	elseif($month!="") 
	{ 
		$sql_where=" where year = $year and month = $month ";
	}
	elseif($year!="") 
	{ 
		$sql_where=" where year = $year ";
	}
	else { }
	
	//if($sql_where=="") { $sql_where2 = " where "; } else { $sql_where2 = " and "; }
	//$sql_where2.=" NbPages > 0 ";


	$sql_max=", (select count(id) as somme from ".HISTORY_TABLE.$sql_where.$sql_group2.") as MaxPages,
		    (select count(image_id) as somme from ".HISTORY_TABLE.$sql_where.$sql_group2.") as MaxImg ";

	$sql=$sql_select.$sql.$sql_thumb.$sql_from.$sql_fromthumb.$sql_max.$sql_where.$sql_group.$sql_order.$sql_limit;

	$result = pwg_query($sql);
	$sql="select FOUND_ROWS()";

	$i=0;
	while ($row = mysql_fetch_array($result))
	{
		$returned0[$i] = $row; $i++;
	}
	$returned[0] = $returned0;

	$result = pwg_query($sql);
	if($result) { $row = mysql_fetch_array($result); $returned[1] = $row[0]; } else { $returned[1] = -1; }
	
	return($returned);
 }


 /* Statistiques par images ----------------------------------------------------------
	Nb vues par image
	%vue sur la période
   par : 
	Images
	Images/années
	Images/années/mois
	Images/années/mois/jour
 ------------------------------------------------------------------------------------ */
 function stats_by_image($year, $month, $day, $nbipperpage, $pagenumber, $sortimg, $ip)
 {
	$sortlist = array("picture" => "NbVues desc, CatName asc, ImgName asc, ImgId asc", "catname" => "CatName asc, ImgName asc, ImgId asc");
	$returned0 = array();

	$sql_select="select SQL_CALC_FOUND_ROWS ";

	$sql="image_id as ImgId, ".IMAGES_TABLE.".name as ImgName, ".CATEGORIES_TABLE.".id as IdCat, ".CATEGORIES_TABLE.".name as CatName, 
count(".HISTORY_TABLE.".image_id) as NbVues, MaxImg.somme, 100*(count(".HISTORY_TABLE.".image_id)/MaxImg.somme) as PctImg, ".IMAGES_TABLE.".path as ThumbPath, ".IMAGES_TABLE.".file as ThumbFile, MaxImg2.somme as NbVuesMax, ".IMAGES_TABLE.".tn_ext as Extension "; 
	
	$sql_from = " from ((".HISTORY_TABLE." LEFT JOIN ".IMAGES_TABLE." ON ".IMAGES_TABLE.".id = ".HISTORY_TABLE.".image_id) LEFT JOIN ".CATEGORIES_TABLE." ON ".CATEGORIES_TABLE.".id = ".IMAGES_TABLE.".storage_category_id) ";
	$sql_from_ip="";

	$sql_where = " where ".HISTORY_TABLE.".image_id is not null ";
	$sql_group=" group by image_id ";
	$sql_order=" order by ".$sortlist[$sortimg]; 
	$sql_limit=" limit ".(($pagenumber-1)* $nbipperpage).", ".$nbipperpage;

	if($day!="") 
	{ 
		$sql_where.=" and year = $year and month = $month and day = $day ";	
	}
	elseif($month!="") 
	{ 
		$sql_where.=" and year = $year and month = $month ";
	}
	elseif($year!="") 
	{ 
		$sql_where.=" and year = $year ";
	}
	else { }

	if($ip!="")
	{ 
		$sql_where.=" and ( (IP = '$ip') or (".USERS_TABLE.".username = '$ip') )";
		$sql_from_ip=" LEFT JOIN ".USERS_TABLE." ON ".USERS_TABLE.".id = ".HISTORY_TABLE.".user_id ";		
	}
	

	$sql_max=", (select count(image_id) as somme from ".HISTORY_TABLE.$sql_from_ip.$sql_where.") as MaxImg, (select count(image_id) as somme from ".HISTORY_TABLE.$sql_from_ip.$sql_where." and ".HISTORY_TABLE.".image_id is not null group by image_id order by somme desc limit 0,1) as MaxImg2 ";

	$sql=$sql_select.$sql.$sql_from.$sql_from_ip.$sql_max.$sql_where.$sql_group.$sql_order.$sql_limit;


	$result = pwg_query($sql);
	$sql="select FOUND_ROWS()";

	$i=0;
	while ($row = mysql_fetch_array($result))
	{
		$returned0[$i] = $row; $i++;
	}
	$returned[0] = $returned0;

	$result = pwg_query($sql);
	if($result) { $row = mysql_fetch_array($result); $returned[1] = $row[0]; } else { $returned[1] = -1; }
	
	return($returned);
 }


 /* Outils : deleted_user ------------------------------------------------------------
	Permet de forcer HISTORY_TABLE.user_id à 2 (guest) pour les enregistrements 
	dont l'identifiant utilisateur n'existe plus dans la table USERS_TABLE
	
	Deux modes :
		- analyse : restitue les informations devant être mises à jour
				* nombre de users concernés
				* nombre d'enregistrement impactés dans HISTORY_TABLE
				* liste des users en question
		- resynchro : met à jour la table		
 ------------------------------------------------------------------------------------ */
 function tools_deleted_user($mode)
 {
	$returned = array(-1,0,'');
	
	if($mode=='analyse')
	{
		$sql="SELECT count(id) as NbRecord, user_id ";
		$sql.=" FROM ".HISTORY_TABLE;
		$sql.=" WHERE ".HISTORY_TABLE.".user_id NOT IN (SELECT id FROM ".USERS_TABLE.") ";
		$sql.=" GROUP BY user_id ORDER BY NbRecord";
		$result=pwg_query($sql);
		if($result)
		{
			$returned[0]=0;
			while ($row = mysql_fetch_array($result))
			{
				$returned[2][$returned[0]][0] = $row[0];
				$returned[2][$returned[0]][1] = $row[1];
				$returned[0]++;
				$returned[1]+=$row[0];
			}
			
		}
	}
	elseif($mode=='resynchro')
	{
		$sql="UPDATE ".HISTORY_TABLE." SET user_id = 2 ";
		$sql.=" WHERE ".HISTORY_TABLE.".user_id NOT IN (SELECT id FROM ".USERS_TABLE.") ";
		$result=pwg_query($sql);
		if($result)
		{ $returned[0]=1; }
	}
	return($returned);
 }


 /* Outils : deleted_picture ---------------------------------------------------------
	analyse l'historique pour trouver les images qui ont été supprimée 	
	Deux modes :
		- analyse : restitue les informations 
				* nombre d'images concernées
				* nombre d'enregistrements impactés dans HISTORY_TABLE
				* liste des images en question
		- resynchro : non implémentée
 ------------------------------------------------------------------------------------ */
 function tools_deleted_picture($mode)
 {
	$returned = array(-1,0,'');
	
	if($mode=='analyse')
	{
		$sql="SELECT count(id) as NbRecord, image_id ";
		$sql.=" FROM ".HISTORY_TABLE;
		$sql.=" WHERE ".HISTORY_TABLE.".image_id NOT IN (SELECT id FROM ".IMAGES_TABLE.") ";
		$sql.=" GROUP BY image_id ORDER BY NbRecord";
		$result=pwg_query($sql);

		if($result)
		{
			$returned[0]=0;
			while ($row = mysql_fetch_array($result))
			{
				$returned[2][$returned[0]][0] = $row[0];
				$returned[2][$returned[0]][1] = $row[1];
				$returned[0]++;
				$returned[1]+=$row[0];
			}
			
		}
	}
	elseif($mode=='resynchro')
	{
	}
	return($returned);
 }


 /* Outils : general_nfo ------------------------------------------------------------
	Fournit quelques informations sur l'historique
 ------------------------------------------------------------------------------------ */
 function tools_general_nfo()
 {
	$returned = array(-1,'','');
 
	$sql="SELECT count(id) AS NbRecord, MAX(concat(date,' ', time)) AS LastDate, MIN(concat(date,' ', time)) AS FirstDate ";
	$sql.=" FROM ".HISTORY_TABLE;
	$result=pwg_query($sql);
	if($result)
	{
		$row = mysql_fetch_array($result);
		if(is_array($row)) { $returned = $row; }
	}
	return($returned);
 }




 /* ------------------------------------------------------------------------------------------
    formate le texte : <a href="$link">$value</a> 
    ------------------------------------------------------------------------------------------ */
 function format_link($value, $link)
 {
   return("<a href='$link'>$value</a>");
 }

 /* ------------------------------------------------------------------------------------------
    change l'extension du nom de fichier  
    ------------------------------------------------------------------------------------------ */
 function change_file_ext($file, $newext)
 {	//un nom de fichier peut être égal à <nom_du_ficher.truc.jpeg> par exemple
	$tmp = explode('.', $file);
	if(count($tmp)>1) { $tmp[count($tmp)-1] = $newext; }	
	return implode('.', $tmp);	   
 }

 /* ------------------------------------------------------------------------------------------
    détermine si la chaine est une adresse IP
    ------------------------------------------------------------------------------------------ */
 function is_IP($ip)
 {	//le test est super basique, mais çà doit suffire pour le besoin
	$tmp=explode('.', $ip);
	if(count($tmp)!=4) 
	{ return (false); }

	for($i=0;$i<4;$i++) 
	{ 
		if(!is_numeric($tmp[$i])) { return (false); } 
	}
	return (true);
 }

 /* ------------------------------------------------------------------------------------------
    restitue le temps d'execution entre deux appels start(true)/stop(false)
    ------------------------------------------------------------------------------------------ */
  function calc_time($start, $prec = 5)
  {	
	global $calc_time_start;
	
	if($start)
	{
		list($usec, $sec) = explode(" ", microtime());
		$calc_time_start = ((float)$usec + (float)$sec);
		return $calc_time_start;		
	}
	else
	{
		list($usec, $sec) = explode(" ", microtime());
		$calc_time_stop = ((float)$usec + (float)$sec);
		return round($calc_time_stop - $calc_time_start, $prec);
	}
  }




 /* ------------------------------------------------------------------------------------------
    génère les stats par période, et les mets en forme dans le template 
    ------------------------------------------------------------------------------------------ */
 function display_stats_by_period($total, $year, $month, $day, $max_width, $seetimerequest)
 {
	global $template, $pagelink;

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_by_period.tpl');


	/* requete */
	calc_time(true);
	$stats = stats_by_period($total, $year, $month, $day);
	$timerequest=calc_time(false);

	$dir_links = "";
	$a_links=array("global" => $pagelink."&fAStat_defper=N&fAStat_all=Y",
			"all" => $pagelink."&fAStat_defper=N&fAStat_all=N",
			"year" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year",
			"month" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");

	$ip_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_ip",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year&fAStat_month=",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year&fAStat_month=$month&fAStat_day=");

	$cat_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_category",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year&fAStat_month=",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year&fAStat_month=$month&fAStat_day=");

	$img_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_image",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_image&fAStat_year=",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_image&fAStat_year=$year&fAStat_month=",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_image&fAStat_year=$year&fAStat_month=$month&fAStat_day=");


	/* onglets */

	make_tabsheet('stats_by_period');
	

	/* libellé de la période + constituation navigation */
	if($day!="") 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_hours")); 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".format_link(l10n("AStat_month_of_year_".$month), $a_links["month"])." / ".l10n("AStat_day_of_week_".date("w",mktime(0, 0, 0, $month, $day, $year)))." $day";
	}
	elseif($month!="") 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_days")); 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".l10n("AStat_month_of_year_".$month);
	}
	elseif($year!="") 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_months")); 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".$year;
	}
	elseif($total!="Y") 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_years")); 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".l10n("AStat_period_label_all");
	}
	else 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_all")); 
		$dir_links = l10n("AStat_period_label_global");
	}	


	/* navigation */
	$template->assign_var("L_STAT_TITLE", $dir_links);
	$template->assign_var("MAX_WIDTH", $max_width+10);
	$template->assign_var("ASTAT_NFO_STAT", l10n("AStat_Nfo_Period"));
	if($seetimerequest=='true') { $template->assign_var("ASTAT_TIME_REQUEST", l10n('AStat_time_request_label').' '.$timerequest.'s'); }


	/* tableau de stat */
	for($i=0;$i<count($stats);$i++)
	{
	    if($stats[$i]["MaxPages"] > 0)
		{ 
		  $width_pages = ceil(($stats[$i]["NbPages"] * $max_width) / $stats[$i]["MaxPages"] ); 
		  $width_img = ceil(($stats[$i]["NbImg"] * $max_width) / $stats[$i]["MaxPages"] );
		  $width_ip = ceil(($stats[$i]["NbIP"] * $max_width) / $stats[$i]["MaxPages"] );
		  $width_cat = ceil(($stats[$i]["NbCat"] * $max_width) / $stats[$i]["MaxPages"] );
		}
		else
		{ 
		  $width_pages = 0; 
		  $width_img = 0;
		  $width_ip = 0;
		  $width_cat = 0;
		}

	
            	if($day!="") 
		{ // si jours sélectionné, heures affichées
			$value=$stats[$i]["Id"];
			$link="";
			$value_ip="";
			$value_cat="";
			$value_img="";
		}
            	elseif($month!="") 
		{ // si mois sélectionné, jours affichés
			$value = $stats[$i]["Id"]." (".l10n("AStat_day_of_week_".date("w",mktime(0, 0, 0, $month, $stats[$i]["Id"], $year))).")";
			$link=$pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=$month&fAStat_day=".$stats[$i]["Id"];
			$value_ip=$ip_links["day"].$stats[$i]["Id"];
			$value_cat=$cat_links["day"].$stats[$i]["Id"];
			$value_img=$img_links["day"].$stats[$i]["Id"];
		}
		elseif($year!="") 
		{ // si année sélectionnée, mois affichés
			$value = l10n("AStat_month_of_year_".$stats[$i]["Id"]);
			$link=$pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=".$stats[$i]["Id"];
			$value_ip=$ip_links["month"].$stats[$i]["Id"];
			$value_cat=$cat_links["month"].$stats[$i]["Id"];
			$value_img=$img_links["month"].$stats[$i]["Id"];
		}
		elseif($total!="Y")
 		{ // si total sélectionné, années affichées
			$value = $stats[$i]["Id"];
			$link=$pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=".$stats[$i]["Id"];
			$value_ip=$ip_links["year"].$stats[$i]["Id"];
			$value_cat=$cat_links["year"].$stats[$i]["Id"];
			$value_img=$img_links["year"].$stats[$i]["Id"];
		}
		else 
		{ 
			$value=l10n("AStat_period_label_all"); 
			$link=$pagelink."&fAStat_defper=N&fAStat_all=N";
			$value_ip=$ip_links["all"];
			$value_cat=$cat_links["all"];
			$value_img=$img_links["all"];
		}


		if((($stats[$i]["NbPages"] + $stats[$i]["NbImg"] + $stats[$i]["NbIP"])>0)&&($link!=""))
		{ $value=format_link($value, $link); }

		if((($stats[$i]["NbIP"])>0)&&($value_ip!=""))
		{ $value_ip=format_link($stats[$i]["NbIP"], $value_ip); }
		else
		{ $value_ip = $stats[$i]["NbIP"]; }

		if((($stats[$i]["NbCat"])>0)&&($value_cat!=""))
		{ $value_cat=format_link($stats[$i]["NbCat"], $value_cat); }
		else
		{ $value_cat= $stats[$i]["NbCat"]; }

		if((($stats[$i]["NbImg"])>0)&&($value_img!=""))
		{ $value_img=format_link($stats[$i]["NbImg"], $value_img); }
		else
		{ $value_img= $stats[$i]["NbImg"]; }



	    $template->assign_block_vars(
	      'stat_by_period_row',
	      array(
	        'VALUE' => $value,
	        'PAGES' => $stats[$i]["NbPages"],
	        'PICTURES' => $value_img,
	        'CATEGORIES' => $value_cat,
	        'IPVISIT' => $value_ip,
	        'WIDTH1' => $width_ip,
	        'WIDTH2' => $width_img,
	        'WIDTH3' => $width_pages,
	        'WIDTH4' => $width_cat,
	        )
	      );
	}
	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
 }
 //------------------------------------------------------------------------------------


 /* ------------------------------------------------------------------------------------------
    génère les stats par IP, et les mets en forme dans le template 
    ------------------------------------------------------------------------------------------ */
 function display_stats_by_ip($year, $month, $day, $max_width, $nbipperpage, $pagenumber, $sortip, $seetimerequest)
 {
	global $template, $pagelink;

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_by_ip.tpl');


	/* requete */
	calc_time(true);
	$returned = stats_by_ip($year, $month, $day, $nbipperpage, $pagenumber, $sortip);
	$timerequest=calc_time(false);
	$stats=$returned[0];
	$nbfoundrows=$returned[1];
	$nbpages=ceil($nbfoundrows / $nbipperpage);



	$dir_links = "";
	$page_link = "";
	$a_links=array("global" => $pagelink."&fAStat_defper=N&fAStat_all=Y",
			"all" => $pagelink."&fAStat_defper=N&fAStat_all=N",
			"year" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year",
			"month" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");

	$ip_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_ip",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");

	$img_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_image",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_image&fAStat_year=$year",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_image&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_image&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");


	/* onglets */

	make_tabsheet('stats_by_ip');
	

	/* constitution navigation */
	if($day!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".format_link(l10n("AStat_month_of_year_".$month), $a_links["month"])." / ".l10n("AStat_day_of_week_".date("w",mktime(0, 0, 0, $month, $day, $year)))." $day";
		$page_link=$ip_links["day"];
		$img_link=$img_links["day"];
	}
	elseif($month!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".l10n("AStat_month_of_year_".$month);
		$page_link=$ip_links["month"];
		$img_link=$img_links["month"];
	}
	elseif($year!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".$year;
		$page_link=$ip_links["year"];
		$img_link=$img_links["year"];
	}
	else 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".l10n("AStat_period_label_all");
		$page_link=$ip_links["all"];
		$img_link=$img_links["all"];
	}
	

	if($nbpages>1) { $plural="s"; } else { $plural=""; }
	$pages_links=l10n("AStat_page".$plural."_label")." : ";
	for($i=1;$i<=$nbpages;$i++)
	{
		if($i==$pagenumber) 
		{ $pages_links.=" $i "; } 
		else
		{
			$pages_links.=format_link(" $i ", $page_link."&fAStat_page_number=$i&fAStat_SortIP=$sortip");
		}
	}



	/* navigation */
	$template->assign_var("L_STAT_TITLE", $dir_links);
	$template->assign_var("MAX_WIDTH", $max_width+10);
	$template->assign_var("NB_TOTAL_IP", l10n('AStat_nb_total_ip')." : $nbfoundrows");
	$template->assign_var("PAGES_LINKS", $pages_links);
	$template->assign_var("ASTAT_NFO_STAT", l10n("AStat_Nfo_IP"));

	$template->assign_var("ASTAT_SORT_LABEL", l10n("AStat_SortIPLabel").strtolower(l10n("AStat_sortip_$sortip")));

	$template->assign_var("ASTAT_LABEL_IP_label", format_link(l10n("AStat_RefIPLabel"), $page_link."&fAStat_SortIP=ip"));
	$template->assign_var("ASTAT_LABEL_Pages_seen", format_link(l10n("Pages seen"), $page_link."&fAStat_SortIP=page"));
	$template->assign_var("ASTAT_LABEL_Pictures_seen", format_link(l10n("Pictures_seen"), $page_link."&fAStat_SortIP=picture"));

	if($seetimerequest=='true') { $template->assign_var("ASTAT_TIME_REQUEST", l10n('AStat_time_request_label').' '.$timerequest.'s'); }


	/* tableau de stat */
	for($i=0;$i<count($stats);$i++)
	{
	    if($stats[$i]["MaxPages"] > 0)
		{ 
		  $width_pages = ceil(($stats[$i]["NbPages"] * $max_width) / $stats[$i]["MaxPages"] ); 
		  $width_img = ceil(($stats[$i]["NbImg"] * $max_width) / $stats[$i]["MaxPages"] );
		}
		else
		{ 
		  $width_pages = 0; 
		  $width_img = 0;
		}


		if(is_ip($stats[$i]["IP"]))
		{
			$ip_geolocalisation='<a href="http://www.geoiptool.com/fr/?IP='.$stats[$i]["IP"].'" title="Geo IP localisation" target="_blank">['.l10n('AStat_IP_geolocalisation').'] </a>';
			$ip_adress='<a href="http://www.ripe.net/whois?form_type=simple&amp;full_query_string=&amp;searchtext='.$stats[$i]["IP"].'+&amp;do_search=Search" title="Ripe Whois" target="_blank">'.$stats[$i]["IP"].'</a>';
		}
		else 
		{
			$ip_geolocalisation='';
			$ip_adress=$stats[$i]["IP"];
		}

	    $template->assign_block_vars(
	      'stat_by_ip_row',
	      array(
	        'ASTAT_IP_GEOLOCALISATION' => $ip_geolocalisation,
		'ASTAT_IP_ADRESS' => $ip_adress,
	        'PAGES' => $stats[$i]["NbPages"],
	        'PICTURES' => format_link($stats[$i]["NbImg"], $img_link."&fAStat_IP=".trim($stats[$i]["IP"])),
	        'WIDTH1' => $width_img,
	        'WIDTH2' => $width_pages,
	        )
	      );
	}
	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
 }






 /* ------------------------------------------------------------------------------------------
    génère les stats par catégories, et les mets en forme dans le template 
    ------------------------------------------------------------------------------------------ */
 function display_stats_by_category($year, $month, $day, $max_width, $nbipperpage, $pagenumber,$showthumb, $sortcat, $seetimerequest)
 {
	global $template, $pagelink, $conf;

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_by_category.tpl');


	/* requete */
	calc_time(true);
	$returned = stats_by_category($year, $month, $day, $nbipperpage, $pagenumber, $showthumb, $sortcat);
	$timerequest=calc_time(false);
	$stats=$returned[0];
	$nbfoundrows=$returned[1];
	$nbpages=ceil($nbfoundrows / $nbipperpage);



	$dir_links = "";
	$page_link = "";
	$a_links=array("global" => $pagelink."&fAStat_defper=N&fAStat_all=Y",
			"all" => $pagelink."&fAStat_defper=N&fAStat_all=N",
			"year" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year",
			"month" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");

	$cat_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_category",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");


	/* onglets */

	make_tabsheet('stats_by_category');
	

	/* constitution navigation */
	if($day!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".format_link(l10n("AStat_month_of_year_".$month), $a_links["month"])." / ".l10n("AStat_day_of_week_".date("w",mktime(0, 0, 0, $month, $day, $year)))." $day";
		$page_link=$cat_links["day"];
	}
	elseif($month!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".l10n("AStat_month_of_year_".$month);
		$page_link=$cat_links["month"];
	}
	elseif($year!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".$year;
		$page_link=$cat_links["year"];
	}
	else 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".l10n("AStat_period_label_all");
		$page_link=$cat_links["all"];
	}
	

	if($nbpages>1) { $plural="s"; } else { $plural=""; }
	$pages_links=l10n("AStat_page".$plural."_label")." : ";
	for($i=1;$i<=$nbpages;$i++)
	{
		if($i==$pagenumber) 
		{ $pages_links.=" $i "; } 
		else
		{
			$pages_links.=format_link(" $i ", $page_link."&fAStat_SortCat=$sortcat&fAStat_page_number=$i");
		}
	}


	/* navigation */
	$template->assign_var("L_STAT_TITLE", $dir_links);
	$template->assign_var("MAX_WIDTH", $max_width);
	$template->assign_var("NB_TOTAL_CATEGORY", l10n('AStat_nb_total_category')." : $nbfoundrows");
	$template->assign_var("PAGES_LINKS", $pages_links);
	$template->assign_var("ASTAT_NFO_STAT", l10n("AStat_Nfo_Category"));
	$template->assign_var("ASTAT_SORT_LABEL", l10n("AStat_SortCatLabel").strtolower(l10n("AStat_sortcat_$sortcat")));

	$template->assign_var("ASTAT_LABEL_pct_Pages_seen", format_link(l10n("pct_Pages_seen"), $page_link."&fAStat_SortCat=page"));
	$template->assign_var("ASTAT_LABEL_pct_Pictures_seen", format_link(l10n("pct_Pictures_seen"), $page_link."&fAStat_SortCat=picture"));
	$template->assign_var("ASTAT_LABEL_ratio_Pictures_seen", format_link(l10n("ratio_Pictures_seen"), $page_link."&fAStat_SortCat=nbpicture"));

	if($seetimerequest=='true') { $template->assign_var("ASTAT_TIME_REQUEST", l10n('AStat_time_request_label').' '.$timerequest.'s'); }

	/* tableau de stat */
	for($i=0;$i<count($stats);$i++)
	{
		 $width_pages = ceil(($stats[$i]["PctPages"] * $max_width)/100 ); 
  		  $width_img = ceil(($stats[$i]["PctImg"] * $max_width)/100 );
		
		if($showthumb=='true')
		{ 
			$filethumb=change_file_ext($stats[$i]["ThumbFile"], $stats[$i]["Extension"]);
			$filethumb=str_replace($stats[$i]["ThumbFile"],"thumbnail/".$conf['prefix_thumbnail'].$filethumb,$stats[$i]["ThumbPath"]); }
		else
		{ $filethumb=''; }

		if($stats[$i]["category_id"]>0)
		{ $category = format_link($stats[$i]["IdCat"], PHPWG_ROOT_PATH."index.php?/category/".$stats[$i]["category_id"]); }
		else
		{ 
			$category = "<i>".l10n('AStat_section_label').' : ';
			if(l10n('AStat_section_'.$stats[$i]["IdCat"])!='AStat_section_'.$stats[$i]["IdCat"])
			{ $category.=l10n('AStat_section_'.$stats[$i]["IdCat"]); }
			else
			{ $category.=sprintf(l10n('AStat_section_unknown'), $stats[$i]["IdCat"]); }
			

			$category.="</i>"; 
		}


	    $template->assign_block_vars(
	      'stat_by_category_row',
	      array(
		'THUMBJPG' => $filethumb,
	        'CATEGORY' => $category, 
	        'PCTPAGES' => $stats[$i]["PctPages"],
	        'PCTPICTURES' => $stats[$i]["PctImg"],
	        'RATIOPICTURES' => $stats[$i]["RatioImg"],
	        'WIDTH1' => $width_img,
	        'WIDTH2' => $width_pages,
	        )
	      );
	}
	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
 }



 /* ------------------------------------------------------------------------------------------
    génère les stats par images, et les mets en forme dans le template 
    ------------------------------------------------------------------------------------------ */
 function display_stats_by_image($year, $month, $day, $max_width, $nbipperpage, $pagenumber,$showthumb, $sortimg, $ip, $seetimerequest)
 {
	global $template, $pagelink, $conf;

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_by_image.tpl');


	/* requete */
	calc_time(true);
	$returned = stats_by_image($year, $month, $day, $nbipperpage, $pagenumber, $sortimg, $ip);
	$timerequest=calc_time(false);
	$stats=$returned[0];
	$nbfoundrows=$returned[1];
	$nbpages=ceil($nbfoundrows / $nbipperpage);

	$dir_links = "";
	$page_link = "";
	$a_links=array("global" => $pagelink."&fAStat_defper=N&fAStat_all=Y",
			"all" => $pagelink."&fAStat_defper=N&fAStat_all=N",
			"year" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year",
			"month" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_defper=N&fAStat_all=N&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");

	$img_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_image",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_image&fAStat_year=$year",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_image&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_image&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");


	/* onglets */

	make_tabsheet('stats_by_image');
	

	/* constitution navigation */
	if($day!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".format_link(l10n("AStat_month_of_year_".$month), $a_links["month"])." / ".l10n("AStat_day_of_week_".date("w",mktime(0, 0, 0, $month, $day, $year)))." $day";
		$page_link=$img_links["day"];
	}
	elseif($month!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".l10n("AStat_month_of_year_".$month);
		$page_link=$img_links["month"];
	}
	elseif($year!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".$year;
		$page_link=$img_links["year"];
	}
	else 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".l10n("AStat_period_label_all");
		$page_link=$img_links["all"];
	}

	if($ip!="")
	{
		$dir_links.= " [IP : $ip]";
	}
	

	if($nbpages>1) { $plural="s"; } else { $plural=""; }
	$pages_links=l10n("AStat_page".$plural."_label")." : ";
	for($i=1;$i<=$nbpages;$i++)
	{
		if($i==$pagenumber) 
		{ $pages_links.=" $i "; } 
		else
		{
			if($ip!="") { $ip_link="&fAStat_IP=$i"; } else { $ip_link=""; }
			$pages_links.=format_link(" $i ", $page_link."&fAStat_SortImg=$sortimg&fAStat_page_number=$i".$ip_link);
		}
	}


	/* navigation */
	$template->assign_var("L_STAT_TITLE", $dir_links);
	$template->assign_var("MAX_WIDTH", $max_width);
	$template->assign_var("NB_TOTAL_IMAGE", l10n('AStat_nb_total_image')." : $nbfoundrows");
	$template->assign_var("PAGES_LINKS", $pages_links);
	$template->assign_var("ASTAT_NFO_STAT", l10n("AStat_Nfo_Image"));
	$template->assign_var("ASTAT_SORT_LABEL", l10n("AStat_SortImgLabel").strtolower(l10n("AStat_sortimg_$sortimg")));

	$template->assign_var("ASTAT_LABEL_AStat_RefImageLabel", format_link(l10n("AStat_RefImageLabel"), $page_link."&fAStat_SortImg=catname"));
	$template->assign_var("ASTAT_LABEL_Pictures_seen", format_link(l10n("Pictures_seen"), $page_link."&fAStat_SortImg=picture"));
	$template->assign_var("ASTAT_LABEL_pct_Pictures_seen", l10n("pct_Pictures_seen"));

	if($seetimerequest=='true') { $template->assign_var("ASTAT_TIME_REQUEST", l10n('AStat_time_request_label').' '.$timerequest.'s'); }

	/* tableau de stat */
	for($i=0;$i<count($stats);$i++)
	{
		 $width_pages = ceil(($stats[$i]["NbVues"] * $max_width)/$stats[$i]["NbVuesMax"] ); 
  		  $width_img = ceil(($stats[$i]["PctImg"] * $max_width)/100 );
		
		if($showthumb=='true')
		{
			$filethumb=change_file_ext($stats[$i]["ThumbFile"], $stats[$i]["Extension"]);
			$filethumb=str_replace($stats[$i]["ThumbFile"],"thumbnail/".$conf['prefix_thumbnail'].$filethumb,$stats[$i]["ThumbPath"]); 
		}
		else
		{ $filethumb=''; }

		$image_links="";
		if($stats[$i]["CatName"]!="") 
		{ $image_links=format_link($stats[$i]["CatName"], PHPWG_ROOT_PATH."index.php?/category/".$stats[$i]["IdCat"])." / "; }
		if($stats[$i]["ImgName"]!="") 
		{ $image_links.=format_link($stats[$i]["ImgName"], PHPWG_ROOT_PATH."picture.php?/".$stats[$i]["ImgId"]."/category/".$stats[$i]["IdCat"]); }
		else
		{ 
			if($stats[$i]["ThumbFile"]!="")
			{ $image_links.=format_link("[ ".$stats[$i]["ThumbFile"]." ]", PHPWG_ROOT_PATH."picture.php?/".$stats[$i]["ImgId"]."/category/".$stats[$i]["IdCat"]); }
			else
			{ $image_links=l10n('AStat_deleted_picture')." [ Id #".$stats[$i]["ImgId"]." ]"; }
		}


	    $template->assign_block_vars(
	      'stat_by_image_row',
	      array(
		'THUMBJPG' => $filethumb,
	        'IMAGE' => $image_links, 
	        'NBPICTURES' => $stats[$i]["NbVues"],
	        'PCTPICTURES' => $stats[$i]["PctImg"],
	        'WIDTH1' => $width_img,
	        'WIDTH2' => $width_pages,
	        )
	      );
	}
	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
 }


 /* ------------------------------------------------------------------------------------------
    génère la page de configuration 
    ------------------------------------------------------------------------------------------ */
 function display_config()
 {
	global $template, $pagelink, $plugin_object;
	$true_false = array('true', 'false');

	$template->assign_var("L_STAT_TITLE", l10n('AStat_config_title'));

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_config.tpl');
	make_tabsheet('config');

	if($plugin_object->save_status==true)
	{ $template->assign_var("ASTAT_RESULT_SAVE", "<p class='infos'>".l10n('AStat_config_saved')."<br/></p>"); }

	/* affectation standard pour zones de saisie */
	reset($plugin_object->my_config); 
	while (list($key, $val) = each($plugin_object->my_config)) 
	{ $template->assign_var("f_".$key, $val); }

	/* gestion spécifique pour les listes */
	// période par défaut
	reset($plugin_object->list_periods); 
	while (list($key, $val) = each($plugin_object->list_periods)) 
	{
	 	if($val==$plugin_object->my_config['AStat_default_period'])
		{ $select='selected'; } else { $select= ''; }

	    $template->assign_block_vars(
	      'AStat_periods_list',
	      array(
	        'VALUE' => $val,
	        'SELECT' => $select,
	        'LABEL' => l10n('AStat_PeriodPerDefault_'.$val)
	        )
	      );
	}
	// tri catégorie par défaut
	reset($plugin_object->list_sortcat); 
	while (list($key, $val) = each($plugin_object->list_sortcat)) 
	{
	 	if($val==$plugin_object->my_config['AStat_DefaultSortCat'])
		{ $select='selected'; } else { $select= ''; }

	    $template->assign_block_vars(
	      'AStat_defaultsortcat_list',
	      array(
	        'VALUE' => $val,
	        'SELECT' => $select,
	        'LABEL' => l10n('AStat_sortcat_'.$val)
	        )
	      );
	}
	// tri ip par défaut
	reset($plugin_object->list_sortip); 
	while (list($key, $val) = each($plugin_object->list_sortip)) 
	{
	 	if($val==$plugin_object->my_config['AStat_DefaultSortIP'])
		{ $select='selected'; } else { $select= ''; }

	    $template->assign_block_vars(
	      'AStat_defaultsortip_list',
	      array(
	        'VALUE' => $val,
	        'SELECT' => $select,
	        'LABEL' => l10n('AStat_sortip_'.$val)
	        )
	      );
	}
	// tri image par défaut
	reset($plugin_object->list_sortimg); 
	while (list($key, $val) = each($plugin_object->list_sortimg)) 
	{
	 	if($val==$plugin_object->my_config['AStat_DefaultSortImg'])
		{ $select='selected'; } else { $select= ''; }

	    $template->assign_block_vars(
	      'AStat_defaultsortimg_list',
	      array(
	        'VALUE' => $val,
	        'SELECT' => $select,
	        'LABEL' => l10n('AStat_sortimg_'.$val)
	        )
	      );
	}


	/* gestion spécifique pour les oui/non */
	$yesno_list=array('AStat_SeeTimeRequests' => 'AStat_see_time_requests_list',
			  'AStat_ShowThumbCat' => 'AStat_showthumbcat_list',
			  'AStat_ShowThumbImg' => 'AStat_showthumbimg_list');
	reset($yesno_list);
	while (list($yesno_key, $yesno_val) = each($yesno_list)) 
	{
		reset($true_false); 
		while (list($key, $val) = each($true_false)) 
		{
			/* see time requests */
		 	if($val==$plugin_object->my_config[$yesno_key])
			{ $select='selected'; } else { $select= ''; }

			$template->assign_block_vars(
				$yesno_val,
		      		array(
				        'VALUE' => $val,
				        'SELECT' => $select,
				        'LABEL' => l10n('AStat_yesno_'.$val)
		        	)
		      	);
		}
	}

	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
 }




 /* ------------------------------------------------------------------------------------------
    génère la page d'outils
    ------------------------------------------------------------------------------------------ */
 function display_tools()
 {
	global $template, $pagelink, $plugin_object;
	$true_false = array('true', 'false');

	$template->assign_var("L_STAT_TITLE", l10n('AStat_tools_title'));

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_tools.tpl');
	make_tabsheet('tools');

	// >> GENERAL NFO ------------------------------------------------------------------------
	$nfo = tools_general_nfo();
	if($nfo[0]>0)
	{
		$template->assign_var("ASTAT_GENERAL_NFO", 
					sprintf(l10n('AStat_tools_general_nfo_nfo'), 
						$nfo[0], 
						date(l10n('AStat_date_time_format'), strtotime($nfo[2])), 
						date(l10n('AStat_date_time_format'), strtotime($nfo[1])) ) );
	}

 	// << GENERAL NFO ------------------------------------------------------------------------
		
	// >> DELETED USER -----------------------------------------------------------------------
	if(isset($_POST['apply_tool_deleted_user'])) 
	{
		$nfo = tools_deleted_user('resynchro');
		if($nfo[0]==1)
		{ $template->assign_var("ASTAT_RESULT_OK", "<p class='infos'>".l10n('AStat_tools_result_ok')."<br/></p>"); }
	}

	$nfo = tools_deleted_user('analyse');
	if($nfo[0]>0)
	{
		$list='';
		for($i=0;$i<count($nfo[2]);$i++) 
		{ 
			if($nfo[2][$i][0]>1) { $s='s'; } else { $s=''; }
			$list.="<li>user_id #".$nfo[2][$i][1]." : ".$nfo[2][$i][0]." ".l10n("AStat_event$s")."</li>"; 
		}
		$template->assign_var("ASTAT_DELETED_USER_NFO", sprintf(l10n('AStat_tools_deleted_user_nfo1'), $nfo[0], $nfo[1], $list));
	}
	else
	{
		$template->assign_var("ASTAT_DELETED_USER_NFO", l10n('AStat_tools_deleted_user_nfo2'));
		$template->assign_var("ASTAT_DELETED_USER_INVISIBLE", ", invisible");
	}	
	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
	// << DELETED USER -----------------------------------------------------------------------

	// >> DELETED PICTURE --------------------------------------------------------------------
	if(isset($_POST['apply_tool_deleted_picture'])) 
	{
		$nfo = tools_deleted_picture('resynchro');
		if($nfo[0]==1)
		{ $template->assign_var("ASTAT_RESULT_OK", "<p class='infos'>".l10n('AStat_tools_result_ok')."<br/></p>"); }
	}

	$nfo = tools_deleted_picture('analyse');
	if($nfo[0]>0)
	{
		$list='';
		for($i=0;$i<count($nfo[2]);$i++) 
		{ 
			if($nfo[2][$i][0]>1) { $s='s'; } else { $s=''; }
			$list.="<li>image_id #".$nfo[2][$i][1]." : ".$nfo[2][$i][0]." ".l10n("AStat_event$s")."</li>"; 
		}
		$template->assign_var("ASTAT_DELETED_PICTURE_NFO", sprintf(l10n('AStat_tools_deleted_picture_nfo1'), $nfo[0], $nfo[1], $list));
		//ne pas afficher le bouton, la fonction n'étant pas encore implémentée
		$template->assign_var("ASTAT_DELETED_PICTURE_INVISIBLE", ", invisible");
	}
	else
	{
		$template->assign_var("ASTAT_DELETED_PICTURE_NFO", l10n('AStat_tools_deleted_picture_nfo2'));
		$template->assign_var("ASTAT_DELETED_PICTURE_INVISIBLE", ", invisible");
	}	
	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
	// << DELETED PICTURE --------------------------------------------------------------------


 }


 /* ------------------------------------------------------------------------------------------
   génère les onglets de la page 
    ------------------------------------------------------------------------------------------ */
 function make_tabsheet($selected_page)
 { //derived from pwg function_tabsheet.inc.php
  global $template, $pagelink;

	  $page['tabsheet'] = array
	  (
	    'stats_by_period' => array
	     (
	      'caption' => l10n('AStat_by_period'),
	      'url' => $pagelink.'&fAStat_tabsheet=stats_by_period',
	      'selected' => ($selected_page=='stats_by_period')	
	     ),
	    'stats_by_ip' => array
	     (
	      'caption' => l10n('AStat_by_ip'),
	      'url' => $pagelink.'&fAStat_tabsheet=stats_by_ip',
	      'selected' => ($selected_page=='stats_by_ip')	
	     ),
	    'stats_by_category' => array
	     (
	      'caption' => l10n('AStat_by_category'),
	      'url' => $pagelink.'&fAStat_tabsheet=stats_by_category',
	      'selected' => ($selected_page=='stats_by_category')
	     ),
	    'stats_by_image' => array
	     (
	      'caption' => l10n('AStat_by_image'),
	      'url' => $pagelink.'&fAStat_tabsheet=stats_by_image',
	      'selected' => ($selected_page=='stats_by_image')
	     ),
	    'config' => array
	     (
	      'caption' => l10n('AStat_config'),
	      'url' => $pagelink.'&fAStat_tabsheet=config',
	      'selected' => ($selected_page=='config')
	     ),
	    'tools' => array
	     (
	      'caption' => l10n('AStat_tools'),
	      'url' => $pagelink.'&fAStat_tabsheet=tools',
	      'selected' => ($selected_page=='tools')
	     )
	  );


  if (count($page['tabsheet']) > 0)
  {
    $template->set_filename('tabsheet', 'admin/tabsheet.tpl');

    foreach ($page['tabsheet'] as $tab_name => $tab)
    {
      $is_selected = ($tab['selected'] == 1);
      $template->assign_block_vars
      (
        'tab',
        array
        (
          'CLASSNAME' => ($is_selected ? 'selected_tab' : 'normal_tab'),
          'URL' => $tab['url'],
          'CAPTION' => $tab['caption']
        )
      );

      if ($is_selected)
      {
        $template->assign_vars(
          array('TABSHEET_TITLE' => '['.$tab['caption'].']'));
      }
    }

    $template->assign_var_from_handle('TABSHEET', 'tabsheet');
  }
 }


?>



